/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.ui.IEditorPart;

import eu.etaxonomy.taxeditor.editor.EditorUtil;

/**
 * <p>SaveAllHandler class.</p>
 *
 * @author n.hoffmann
 * @created 06.02.2009
 * @version 1.0
 */
public class SaveAllHandler extends AbstractHandler implements IHandler {
	private static final Logger logger = Logger.getLogger(SaveAllHandler.class);

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	/** {@inheritDoc} */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		logger.debug("Handler called: " + this.getClass().getCanonicalName());
		
		// TODO what is this for?
		EditorUtil.setSaving(true);
		
		for (IEditorPart editor : EditorUtil.getOpenEditors()) {
			if (editor.isDirty()) {
				editor.doSave(EditorUtil.getMonitor());
			}
		}
		
		EditorUtil.setSaving(false);
		// TODO: delete undoHistory
		return null;
	}
}
