package eu.etaxonomy.taxeditor.editor.name.operation;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.operations.IUndoContext;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.cdm.api.conversation.IConversationEnabled;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.TaxonEditorInput;
import eu.etaxonomy.taxeditor.operation.AbstractPersistentPostOperation;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;

public class DeleteTaxonBaseOperation extends AbstractPersistentPostOperation {
	
	private IWorkbenchPage activePage;
	
	public DeleteTaxonBaseOperation(String label, IUndoContext undoContext,
			Taxon taxon, IWorkbenchPage activePage, IPostOperationEnabled postOperationEnabled, IConversationEnabled conversationEnabled) {
		super(label, undoContext, postOperationEnabled,
				 conversationEnabled);
		this.activePage = activePage;
		
	}

	@Override
	public IStatus execute(IProgressMonitor monitor, IAdaptable info)
			throws ExecutionException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IStatus redo(IProgressMonitor monitor, IAdaptable info)
			throws ExecutionException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IStatus undo(IProgressMonitor monitor, IAdaptable info)
			throws ExecutionException {
		// TODO Auto-generated method stub
		return null;
	}
	
	protected void closeObsoleteEditor(Taxon taxon){
		for (IEditorReference ref : activePage.getEditorReferences()) {
			
			IViewPart view =  activePage.findView("eu.etaxonomy.taxeditor.navigation.navigator");
		
			try {
				IEditorInput input = ref.getEditorInput(); 
				if (input instanceof TaxonEditorInput) {
					TaxonNode node = ((TaxonEditorInput) input).getTaxonNode();
					if (taxonNode.equals(node)) {
						activePage.closeEditor(ref.getEditor(false), false);
					}
				}
			} catch (PartInitException e) {
				continue;
			}
		}
	}
}


